=== ns-3.12.1/src/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

import os, os.path
import sys
import shutil
import types
import warnings

import TaskGen
import Task
import Options
import Build
import Utils
import Constants

import ccroot
ccroot.USE_TOP_LEVEL = True

import wutils

try:
    set
except NameError:
    from sets import Set as set # Python 2.3 fallback

all_modules = [
    'core',
    'network',
    'config-store',
    'internet',
    'propagation',
    'point-to-point',
    'csma',
    'emu',
    'bridge',
    'tap-bridge',
    'virtual-net-device',
    'applications',
    'nix-vector-routing',
    'olsr',
    'aodv',
    'dsdv',
    'click',
    'openflow',
    'mobility',
    'wifi',
    'netanim',
    'stats',
    'uan',
    'spectrum',
    'mesh',   
    'test',
    'test/ns3tcp',
    'test/ns3wifi',
    'flow-monitor',
    'wimax',
    'lte',
    'mpi',
    'topology-read',
    'energy',
    'tools',
    'visualizer',
    'point-to-point-layout',
    'csma-layout',
    'template',
    ]

def set_options(opt):
    opt.sub_options('core')
    opt.sub_options('click')
    opt.sub_options('openflow')

    opt.add_option('--enable-rpath',
                   help=("Link programs with rpath"
                         " (normally not needed, see "
                         " --run and --shell; moreover, only works in some"
                         " specific platforms, such as Linux and Solaris)"),
                   action="store_true", dest='enable_rpath', default=False)
    
    opt.add_option('--enable-modules',
                   help=("Build only these modules (and dependencies)"),
                   dest='enable_modules')

def configure(conf):
    conf.sub_config('core')
    conf.sub_config('emu')
    conf.sub_config('tap-bridge')
    conf.sub_config('config-store')
    conf.sub_config('internet')
    conf.sub_config('netanim')
    conf.sub_config('test')
    conf.sub_config('click')
    conf.sub_config('openflow')
    conf.sub_config('stats')
    conf.sub_config('visualizer')

    blddir = os.path.abspath(os.path.join(conf.blddir, conf.env.variant()))
    conf.env.append_value('NS3_MODULE_PATH', blddir)
    if Options.options.enable_rpath:
        conf.env.append_value('RPATH', '-Wl,-rpath=%s' % (os.path.join(blddir),))

    ## Used to link the 'test-runner' program with all of ns-3 code
    conf.env['NS3_MODULES'] = ['ns3-' + module.split('/')[-1] for module in all_modules]


class ns3module_taskgen(TaskGen.task_gen):
    def __init__(self, *args, **kwargs):
        super(ns3module_taskgen, self).__init__(*args, **kwargs)
        self.libs = []

    def apply(self):
        static_enabled = False
        shared_enabled = True
        bld = self.bld
        if bld.env['ENABLE_STATIC_NS3']:
            static_enabled = True
            shared_enabled = False
        if bld.env['ENABLE_SHARED_AND_STATIC_NS3']:
            static_enabled = True
            shared_enabled = True

        assert self.name.startswith("ns3-")
        name = self.name.split("ns3-")[1]

        if static_enabled:
            static = self._create_ns3_module(self.bld, name, self.dependencies, True)
            self.libs.append(static)
        else:
            static = None

        if shared_enabled:
            shared = self._create_ns3_module(self.bld, name, self.dependencies, False)
            self.libs.append(shared)
        else:
            shared = None

        if static is not None and shared is None:
            static.name = self.name + "--lib"
            static.uselib_local = ['ns3-%s--lib' % (dep,) for dep in self.dependencies]

        elif shared is not None and static is None:
            shared.name = self.name + "--lib"
            shared.uselib_local = ['ns3-%s--lib' % (dep,) for dep in self.dependencies]
        else:
            shared.name = self.name + "--lib"
            shared.uselib_local = ['ns3-%s--lib' % (dep,) for dep in self.dependencies]
            static.name = self.name + "--static"
            static.uselib_local = ['ns3-%s--static' % (dep,) for dep in self.dependencies]

        if not self.test:
            pcfile = bld.new_task_gen('ns3pcfile')
            pcfile.module = self

    def _create_ns3_module(self, bld, name, dependencies, static):

        # FIXME: env modifications are overwritten by parent caller

        # Create a separate library for this module.
        if static:
            module = bld.new_task_gen('cxx', 'cstaticlib')
        else:
            module = bld.new_task_gen('cxx', 'cshlib')

        module.source = self.source
        module.env = self.env.copy()
        features = list(self.features)
        features.remove("ns3module")
        module.features.extend(features)
        module.path = self.path
        module.uselib = self.uselib
        module.target = 'ns3-' + name
        if hasattr(self, 'includes'):
            module.includes = self.includes
        if hasattr(self, 'defines'):
            module.defines = self.defines
        else:
            module.defines = []
        if hasattr(self, 'add_objects'):
            module.add_objects = self.add_objects
        else:
            module.add_objects = []
        if hasattr(self, "is_ns3_module"):
            module.is_ns3_module = self.is_ns3_module
        if hasattr(self, 'add_objects'):
            module.add_objects = self.add_objects

        linkflags = []
        cxxflags = []
        ccflags = []
        if not static:
            cxxflags = module.env['shlib_CXXFLAGS']
            ccflags = module.env['shlib_CXXFLAGS']
            # Turn on the link flags for shared libraries if we have the
            # proper compiler and platform.
            if module.env['CXX_NAME'] in ['gcc', 'icc'] and module.env['WL_SONAME_SUPPORTED']:
                # Get the module library name without any relative paths
                # at its beginning because all of the libraries will end
                # up in the same directory.
                module_library_name = os.path.basename(ccroot.get_target_name(module))
                linkflags = '-Wl,--soname=%s' % module_library_name
        elif module.env['CXX_NAME'] in ['gcc', 'icc'] and \
                os.uname()[4] == 'x86_64' and \
                sys.platform != 'darwin' and \
                module.env['ENABLE_PYTHON_BINDINGS']:
            # enable that flag for static builds only on x86-64 platforms
            # when gcc is present and only when we want python bindings
            # (it's more efficient to not use this option if we can avoid it)
            cxxflags = ['-mcmodel=large']
            ccflags = ['-mcmodel=large']
        cxxdefines = ["NS3_MODULE_COMPILATION"]
        ccdefines = ["NS3_MODULE_COMPILATION"]

        module.env.append_value('CXXFLAGS', cxxflags)
        module.env.append_value('CCFLAGS', ccflags)
        module.env.append_value('LINKFLAGS', linkflags)
        module.env.append_value('CXXDEFINES', cxxdefines)
        module.env.append_value('CCDEFINES', ccdefines)

        if len(module.source) > 0 and hasattr(self, 'ns3_dir_location'):
            uselib_cpppath = []
            for lib in module.uselib.split():
                if 'CPPPATH_%s' % lib in module.env:
                    uselib_cpppath.extend(module.env['CPPPATH_%s' % lib])
            objects = []
            for src in module.source[0:-1]:
                full_src = os.path.join(self.ns3_dir_location, src)
                path = os.path.dirname(full_src)
                target = '%s_object' % src
                # XXX: calculate the features correctly here.
                obj = bld (source=[full_src], target=target, features='cxx cc',
                           defines=['NS_TEST_SOURCEDIR="%s"' % path], 
                           includes=' '.join(uselib_cpppath),
                           env = module.env)
                objects.append(target)
            last = module.source[-1]
            full_src = os.path.join(self.ns3_dir_location, last)
            path = os.path.dirname(full_src)
            module.defines.append('NS_TEST_SOURCEDIR="%s"' % path)
            module.source = [last]
            module.add_objects.extend(objects)


        module.is_static = static
        module.vnum = wutils.VNUM
        # Add the proper path to the module's name.
        module.target = '%s/ns3-%s' % (bld.srcnode.relpath_gen(self.path), name)
        # Set the libraries this module depends on.  
        module.module_deps = list(dependencies)

        module.install_path = "${LIBDIR}"

        return module


def create_ns3_module(bld, name, dependencies=(), test=False):
    module = bld.new_task_gen('ns3module')
    module.bld = bld
    module.name = "ns3-" + name
    module.dependencies = dependencies
    # Initially create an empty value for this because the pcfile
    # writing task assumes every module has a uselib attribute.
    module.uselib = ''
    module.uselib_local = ['ns3-' + dep for dep in dependencies]
    module.module_deps = list(dependencies)
    module.test = test
    module.is_ns3_module = True
    module.ns3_dir_location = bld.path.relpath_gen(bld.srcnode)

    return module


def create_ns3_module_test_library(bld, name):
    # Create an ns3 module for the test library that depends only on
    # the module being tested.
    library_name = name + "-test"
    library = bld.create_ns3_module(library_name, [name], test = True)

    # Modify attributes for the test library that are different from a
    # normal module.
    del library.is_ns3_module
    library.is_ns3_module_test_library = True
    library.module_name = 'ns3-' + name

    # Add this module and test library to the list.
    bld.env.append_value('NS3_MODULES_WITH_TEST_LIBRARIES', (library.module_name, library.name))

    # Set the include path from the build directory to modules. 
    relative_path_from_build_to_here = bld.path.relpath_gen(bld.bldnode)
    include_flag = '-I' + relative_path_from_build_to_here
    library.env.append_value('CXXFLAGS', include_flag)
    library.env.append_value('CCFLAGS',  include_flag)

    return library

def create_obj(bld, *args):
    warnings.warn("(in %s) Use bld.new_task_gen(...) now, instead of bld.create_obj(...)" % str(bld.path),
                  DeprecationWarning, stacklevel=2)
    return bld.new_task_gen(*args)


def ns3_python_bindings(bld):
    # this method is called from a module wscript, so remember bld.path is not bindings/python!
    module_abs_src_path = bld.path.abspath()
    module = os.path.basename(module_abs_src_path)
    env = bld.env
    env.append_value("MODULAR_BINDINGS_MODULES", "ns3-"+module)

    if not env['ENABLE_PYTHON_BINDINGS']:
        return

    bindings_dir = bld.path.find_dir("bindings")
    if bindings_dir is None or not os.path.exists(bindings_dir.abspath()):
        warnings.warn("(in %s) Requested to build modular python bindings, but apidefs dir not found "
                      "=> skipped the bindings." % str(bld.path),
                      Warning, stacklevel=2)
        return

    if ("ns3-%s" % (module,)) not in env.NS3_ENABLED_MODULES:
        #print "bindings for module %s which is not enabled, skip" % module
        return

    env.append_value('PYTHON_MODULES_BUILT', module)
    apidefs = env['PYTHON_BINDINGS_APIDEFS'].replace("-", "_")

    #debug = ('PYBINDGEN_DEBUG' in os.environ)
    debug = True # XXX
    source = [bld.srcnode.find_resource('bindings/python/ns3modulegen-modular.py').relpath_gen(bld.path),
              "bindings/modulegen__%s.py" % apidefs]

    if bindings_dir.find_resource("modulegen_customizations.py") is not None:
        source.append("bindings/modulegen_customizations.py")

    # the local customization file may or not exist
    if bld.path.find_resource("bindings/modulegen_local.py"):
        source.append("bindings/modulegen_local.py")

    module_py_name = module.replace('-', '_')
    module_target_dir = bld.srcnode.find_dir("bindings/python/ns").relpath_gen(bld.path)
