=== pybindgen-0.15.0.795/examples/wscript ===
## -*- python -*-

def set_options(opt):
    pass#opt.tool_options('boost')

def build(bld):
    bld.add_subdirs('a b c d e f g h')
    bld.add_subdirs('callback')
    bld.add_subdirs('buffer')
    #if bld.env['HAVE_BOOST']:
    #    bld.add_subdirs('shared_ptr')

def configure(conf):
    pass
    #conf.env['HAVE_BOOST'] = conf.check_boost()
