=== debian/changelog ===
ns3 (3.12.1+dfsg1-3) unstable; urgency=low

  [debian/rules]:
    * add -v option to test.py to show more details.
    * use '-j1' option to build when memory is less than 3GiB.
    * disable "--as-needed" temporarily, the upstream claimed 
      that it will be fixed in next release.
   [build.py]:
    * drop "--doxygen-no-build", which is not for configure.
    * new build.py with --build-option and "-- --options-for-waf" .
         -- Thanks to Gustavo J. A. M. Carneiro <gjcarneiro@gmail.com>.

 -- YunQiang Su <wzssyqa@gmail.com>  Wed, 21 Sep 2011 01:45:49 +0800

ns3 (3.12.1+dfsg1-2) unstable; urgency=low

  * fix the issue that doesn't generate on non-x86 
    and non-linux arch [ns3-static.diff].

 -- YunQiang Su <wzssyqa@gmail.com>  Mon, 19 Sep 2011 18:23:02 +0800

ns3 (3.12.1+dfsg1-1) unstable; urgency=low

  New Upstream version.
  [ Aron Xu ]
  * Correct Vcs-Browser field.

  [ YunQiang Su ]
  * Imported Upstream version 3.12
  * drop , models-doc-ftbfs.diff,
        modules-so-version.diff; fixed in upstream
  * remove build-py-ns3-option.diff and gen-static-libraries.diff, 
    use another way to do it: upstream-back/*.
  * add some build-dep-indep the last version lost.(Closes: #634544)
  * Only install python modules for default version(Closes: #628909):
          How to build it for multi versions of python?
  * run test after build (Closes: #630184).
  * transit to dh_python2 (Closes: #637518).
  * New debug packages: libns3-3-dbg and python-ns3-dbg.

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 1 Sep 2011 13:14:23 +0800

ns3 (3.11+dfsg1-1) unstable; urgency=low

  * New Upstream Version
  * rm waf bin file (dfsg) and add waf source files
  * doxygen itself depends on doxygen-latex now (Closes: #616271)
  * Close an invaild FTBFS (Closes: #625011)
  * Remove waf bin file from orig tar
  * More details in debian/copyright

 -- YunQiang Su <wzssyqa@gmail.com>  Fri, 27 May 2011 14:26:47 +0800
